Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/src/Core_Glue_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/src/Core_Glue_allocation.cpp	(revision 109)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/src/Core_Glue_allocation.cpp	(revision 111)
@@ -234,14 +234,25 @@
 
     // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
-    _priority  = new generic::priority::Priority * [_param->_nb_execute_loop];
+    _priority_ooo_engine  = new generic::priority::Priority * [_param->_nb_execute_loop];
+    _priority_read_unit   = new generic::priority::Priority * [_param->_nb_execute_loop];
 
     for (uint32_t i=0; i<_param->_nb_execute_loop; ++i)
-      _priority [i] = new generic::priority::Priority (_name+"_priority_"+toString(i),
-                                                       _param->_dispatch_priority      ,
-                                                       _param->_dispatch_load_balancing,
-                                                       _param->_execute_loop_nb_ooo_engine [i],
-                                                       _param->_execute_loop_nb_inst_issue [i],
-                                                       _param->_execute_loop_nb_ooo_engine [i]
-                                                       );
+      {
+        _priority_ooo_engine [i] = new generic::priority::Priority (_name+"_priority_ooo_engine_"+toString(i),
+                                                                    _param->_dispatch_priority      ,
+                                                                    _param->_dispatch_load_balancing,
+                                                                    _param->_execute_loop_nb_ooo_engine [i],
+                                                                    _param->_execute_loop_nb_inst_issue [i],
+                                                                    _param->_execute_loop_nb_ooo_engine [i]
+                                                                    );
+
+        _priority_read_unit  [i] = new generic::priority::Priority (_name+"_priority_read_unit_"+toString(i),
+                                                                    // PRIORITY_STATIC,
+                                                                    PRIORITY_ROUND_ROBIN,
+                                                                    _param->_nb_read_unit [i],
+                                                                    _param->_nb_read_unit [i]
+                                                                    );
+      }
+
 
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/src/Core_Glue_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/src/Core_Glue_deallocation.cpp	(revision 109)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/src/Core_Glue_deallocation.cpp	(revision 111)
@@ -159,6 +159,10 @@
     // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
     for (uint32_t i=0; i<_param->_nb_execute_loop; ++i)
-      delete _priority [i];
-    delete [] _priority;
+      {
+        delete _priority_ooo_engine [i];
+        delete _priority_read_unit  [i];
+      }
+    delete [] _priority_ooo_engine;
+    delete [] _priority_read_unit ;
 
     delete _component;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/src/Core_Glue_genMealy_issue.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/src/Core_Glue_genMealy_issue.cpp	(revision 109)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/src/Core_Glue_genMealy_issue.cpp	(revision 111)
@@ -42,12 +42,12 @@
         log_printf(TRACE,Core_Glue,FUNCTION,"  * execute_loop [%d]",i);
 
-        std::list<generic::priority::select_t> * select = _priority[i] ->select();
-        for (std::list<generic::priority::select_t>::iterator it=select ->begin();
-             it!=select->end();
-             ++it)
+        std::list<generic::priority::select_t> * select_ooo_engine = _priority_ooo_engine[i]->select();
+        for (std::list<generic::priority::select_t>::iterator it_ooo_engine=select_ooo_engine->begin();
+             it_ooo_engine!=select_ooo_engine->end();
+             ++it_ooo_engine)
           {
-            const uint32_t ooo_engine_id  = it->grp;
+            const uint32_t ooo_engine_id  = it_ooo_engine->grp;
             const uint32_t num_ooo_engine = _param->_translate_execute_loop_num_ooo_engine [i][ooo_engine_id];
-            const uint32_t num_inst_issue = it->elt;
+            const uint32_t num_inst_issue = it_ooo_engine->elt;
 
             log_printf(TRACE,Core_Glue,FUNCTION,"    * num_ooo_engine [%d] (id : %d)",num_ooo_engine, ooo_engine_id);
@@ -56,48 +56,57 @@
 
             // have request ?
-            if (PORT_READ(in_ISSUE_OOO_ENGINE_VAL [num_ooo_engine][num_inst_issue]))
+            Tcontrol_t ooo_engine_val = PORT_READ(in_ISSUE_OOO_ENGINE_VAL [num_ooo_engine][num_inst_issue]);
+
+//             if (ooo_engine_val)
               {
 //              // If ooo_engine can issue instruction on multiple execute_loop
 //              if (not ISSUE_OOO_ENGINE_ACK [num_ooo_engine][num_inst_issue])
-                for (uint32_t j=0; j<_param->_nb_read_unit[i]; ++j)
+
+                std::list<generic::priority::select_t> * select_read_unit = _priority_read_unit[i]->select();
+                for (std::list<generic::priority::select_t>::iterator it_read_unit=select_read_unit->begin();
+                     it_read_unit!=select_read_unit->end();
+                     ++it_read_unit)
+                  {
+                    uint32_t num_read_unit = it_read_unit->grp;
+
                   // Test if have an link and read unit is enable
-                  {
-                  log_printf(TRACE,Core_Glue,FUNCTION,"    * read_unit               : %d",j);
-                  log_printf(TRACE,Core_Glue,FUNCTION,"      * READ_UNIT_ENABLE      : %d",READ_UNIT_ENABLE [i][j]);
-                  log_printf(TRACE,Core_Glue,FUNCTION,"      * table_dispatch        : %d",_param->_table_dispatch [num_ooo_engine][num_inst_issue][i][j]);
+                  log_printf(TRACE,Core_Glue,FUNCTION,"    * read_unit               : %d",num_read_unit);
+                  log_printf(TRACE,Core_Glue,FUNCTION,"      * READ_UNIT_ENABLE      : %d",READ_UNIT_ENABLE [i][num_read_unit]);
+                  log_printf(TRACE,Core_Glue,FUNCTION,"      * table_dispatch        : %d",_param->_table_dispatch [num_ooo_engine][num_inst_issue][i][num_read_unit]);
 
-                  if (READ_UNIT_ENABLE [i][j] and 
-                      _param->_table_dispatch [num_ooo_engine][num_inst_issue][i][j])
+                  Tcontrol_t read_unit_enable = READ_UNIT_ENABLE [i][num_read_unit];
+                  if (read_unit_enable and 
+                      _param->_table_dispatch [num_ooo_engine][num_inst_issue][i][num_read_unit])
                     {
                       // Transaction
-                      ISSUE_EXECUTE_LOOP_VAL [i][j] = 1;
-                      ISSUE_OOO_ENGINE_ACK   [num_ooo_engine][num_inst_issue] = 1;
-                      READ_UNIT_ENABLE       [i][j] = false; // now, this read_unit is busy
+                      ISSUE_EXECUTE_LOOP_VAL [i][num_read_unit] = ooo_engine_val;
+                      ISSUE_OOO_ENGINE_ACK   [num_ooo_engine][num_inst_issue] = read_unit_enable; // = 1
+                      READ_UNIT_ENABLE       [i][num_read_unit] = false; // now, this read_unit is busy
 
                       if (_param->_have_port_context_id)
-                      PORT_WRITE(out_ISSUE_EXECUTE_LOOP_CONTEXT_ID            [i][j],PORT_READ(in_ISSUE_OOO_ENGINE_CONTEXT_ID            [num_ooo_engine][num_inst_issue]));
+                      PORT_WRITE(out_ISSUE_EXECUTE_LOOP_CONTEXT_ID            [i][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_CONTEXT_ID            [num_ooo_engine][num_inst_issue]));
                       if (_param->_have_port_front_end_id)
-                      PORT_WRITE(out_ISSUE_EXECUTE_LOOP_FRONT_END_ID          [i][j],PORT_READ(in_ISSUE_OOO_ENGINE_FRONT_END_ID          [num_ooo_engine][num_inst_issue]));
+                      PORT_WRITE(out_ISSUE_EXECUTE_LOOP_FRONT_END_ID          [i][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_FRONT_END_ID          [num_ooo_engine][num_inst_issue]));
                       if (_param->_have_port_ooo_engine_id)
-                      PORT_WRITE(out_ISSUE_EXECUTE_LOOP_OOO_ENGINE_ID         [i][j],ooo_engine_id);
+                      PORT_WRITE(out_ISSUE_EXECUTE_LOOP_OOO_ENGINE_ID         [i][num_read_unit],ooo_engine_id);
                       if (_param->_have_port_rob_ptr)
-                      PORT_WRITE(out_ISSUE_EXECUTE_LOOP_PACKET_ID             [i][j],PORT_READ(in_ISSUE_OOO_ENGINE_PACKET_ID             [num_ooo_engine][num_inst_issue]));
-                      PORT_WRITE(out_ISSUE_EXECUTE_LOOP_OPERATION             [i][j],PORT_READ(in_ISSUE_OOO_ENGINE_OPERATION             [num_ooo_engine][num_inst_issue]));
-                      PORT_WRITE(out_ISSUE_EXECUTE_LOOP_TYPE                  [i][j],PORT_READ(in_ISSUE_OOO_ENGINE_TYPE                  [num_ooo_engine][num_inst_issue]));
-                      PORT_WRITE(out_ISSUE_EXECUTE_LOOP_STORE_QUEUE_PTR_WRITE [i][j],PORT_READ(in_ISSUE_OOO_ENGINE_STORE_QUEUE_PTR_WRITE [num_ooo_engine][num_inst_issue]));
+                      PORT_WRITE(out_ISSUE_EXECUTE_LOOP_PACKET_ID             [i][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_PACKET_ID             [num_ooo_engine][num_inst_issue]));
+                      PORT_WRITE(out_ISSUE_EXECUTE_LOOP_OPERATION             [i][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_OPERATION             [num_ooo_engine][num_inst_issue]));
+                      PORT_WRITE(out_ISSUE_EXECUTE_LOOP_TYPE                  [i][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_TYPE                  [num_ooo_engine][num_inst_issue]));
+                      PORT_WRITE(out_ISSUE_EXECUTE_LOOP_STORE_QUEUE_PTR_WRITE [i][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_STORE_QUEUE_PTR_WRITE [num_ooo_engine][num_inst_issue]));
                       if (_param->_have_port_load_queue_ptr)
-                      PORT_WRITE(out_ISSUE_EXECUTE_LOOP_LOAD_QUEUE_PTR_WRITE  [i][j],PORT_READ(in_ISSUE_OOO_ENGINE_LOAD_QUEUE_PTR_WRITE  [num_ooo_engine][num_inst_issue]));
-                      PORT_WRITE(out_ISSUE_EXECUTE_LOOP_HAS_IMMEDIAT          [i][j],PORT_READ(in_ISSUE_OOO_ENGINE_HAS_IMMEDIAT          [num_ooo_engine][num_inst_issue]));
-                      PORT_WRITE(out_ISSUE_EXECUTE_LOOP_IMMEDIAT              [i][j],PORT_READ(in_ISSUE_OOO_ENGINE_IMMEDIAT              [num_ooo_engine][num_inst_issue]));
-                      PORT_WRITE(out_ISSUE_EXECUTE_LOOP_READ_RA               [i][j],PORT_READ(in_ISSUE_OOO_ENGINE_READ_RA               [num_ooo_engine][num_inst_issue]));
-                      PORT_WRITE(out_ISSUE_EXECUTE_LOOP_NUM_REG_RA            [i][j],PORT_READ(in_ISSUE_OOO_ENGINE_NUM_REG_RA            [num_ooo_engine][num_inst_issue]));
-                      PORT_WRITE(out_ISSUE_EXECUTE_LOOP_READ_RB               [i][j],PORT_READ(in_ISSUE_OOO_ENGINE_READ_RB               [num_ooo_engine][num_inst_issue]));
-                      PORT_WRITE(out_ISSUE_EXECUTE_LOOP_NUM_REG_RB            [i][j],PORT_READ(in_ISSUE_OOO_ENGINE_NUM_REG_RB            [num_ooo_engine][num_inst_issue]));
-                      PORT_WRITE(out_ISSUE_EXECUTE_LOOP_READ_RC               [i][j],PORT_READ(in_ISSUE_OOO_ENGINE_READ_RC               [num_ooo_engine][num_inst_issue]));
-                      PORT_WRITE(out_ISSUE_EXECUTE_LOOP_NUM_REG_RC            [i][j],PORT_READ(in_ISSUE_OOO_ENGINE_NUM_REG_RC            [num_ooo_engine][num_inst_issue]));
-                      PORT_WRITE(out_ISSUE_EXECUTE_LOOP_WRITE_RD              [i][j],PORT_READ(in_ISSUE_OOO_ENGINE_WRITE_RD              [num_ooo_engine][num_inst_issue]));
-                      PORT_WRITE(out_ISSUE_EXECUTE_LOOP_NUM_REG_RD            [i][j],PORT_READ(in_ISSUE_OOO_ENGINE_NUM_REG_RD            [num_ooo_engine][num_inst_issue]));
-                      PORT_WRITE(out_ISSUE_EXECUTE_LOOP_WRITE_RE              [i][j],PORT_READ(in_ISSUE_OOO_ENGINE_WRITE_RE              [num_ooo_engine][num_inst_issue]));
-                      PORT_WRITE(out_ISSUE_EXECUTE_LOOP_NUM_REG_RE            [i][j],PORT_READ(in_ISSUE_OOO_ENGINE_NUM_REG_RE            [num_ooo_engine][num_inst_issue]));
+                      PORT_WRITE(out_ISSUE_EXECUTE_LOOP_LOAD_QUEUE_PTR_WRITE  [i][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_LOAD_QUEUE_PTR_WRITE  [num_ooo_engine][num_inst_issue]));
+                      PORT_WRITE(out_ISSUE_EXECUTE_LOOP_HAS_IMMEDIAT          [i][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_HAS_IMMEDIAT          [num_ooo_engine][num_inst_issue]));
+                      PORT_WRITE(out_ISSUE_EXECUTE_LOOP_IMMEDIAT              [i][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_IMMEDIAT              [num_ooo_engine][num_inst_issue]));
+                      PORT_WRITE(out_ISSUE_EXECUTE_LOOP_READ_RA               [i][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_READ_RA               [num_ooo_engine][num_inst_issue]));
+                      PORT_WRITE(out_ISSUE_EXECUTE_LOOP_NUM_REG_RA            [i][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_NUM_REG_RA            [num_ooo_engine][num_inst_issue]));
+                      PORT_WRITE(out_ISSUE_EXECUTE_LOOP_READ_RB               [i][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_READ_RB               [num_ooo_engine][num_inst_issue]));
+                      PORT_WRITE(out_ISSUE_EXECUTE_LOOP_NUM_REG_RB            [i][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_NUM_REG_RB            [num_ooo_engine][num_inst_issue]));
+                      PORT_WRITE(out_ISSUE_EXECUTE_LOOP_READ_RC               [i][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_READ_RC               [num_ooo_engine][num_inst_issue]));
+                      PORT_WRITE(out_ISSUE_EXECUTE_LOOP_NUM_REG_RC            [i][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_NUM_REG_RC            [num_ooo_engine][num_inst_issue]));
+                      PORT_WRITE(out_ISSUE_EXECUTE_LOOP_WRITE_RD              [i][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_WRITE_RD              [num_ooo_engine][num_inst_issue]));
+                      PORT_WRITE(out_ISSUE_EXECUTE_LOOP_NUM_REG_RD            [i][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_NUM_REG_RD            [num_ooo_engine][num_inst_issue]));
+                      PORT_WRITE(out_ISSUE_EXECUTE_LOOP_WRITE_RE              [i][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_WRITE_RE              [num_ooo_engine][num_inst_issue]));
+                      PORT_WRITE(out_ISSUE_EXECUTE_LOOP_NUM_REG_RE            [i][num_read_unit],PORT_READ(in_ISSUE_OOO_ENGINE_NUM_REG_RE            [num_ooo_engine][num_inst_issue]));
                     }            
                   }
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/src/Core_Glue_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/src/Core_Glue_transition.cpp	(revision 109)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/src/Core_Glue_transition.cpp	(revision 111)
@@ -24,5 +24,8 @@
       {
         for (uint32_t i=0; i<_param->_nb_execute_loop; ++i)
-          _priority [i]->reset();
+          {
+            _priority_ooo_engine [i]->reset();
+            _priority_read_unit  [i]->reset();
+          }
       }
     else
@@ -30,5 +33,8 @@
 	// next priority
         for (uint32_t i=0; i<_param->_nb_execute_loop; ++i)
-          _priority [i]->transition();
+          {
+            _priority_ooo_engine [i]->transition();
+            _priority_read_unit  [i]->transition();
+          }
       }
 
